local Boom = {Active = {}, CurSpec = nil, buttons = {}}
local twelve = 9
if UnitName("player") == "Goranaws" then
	twelve = 12
end

local Balance, Feral, Resoration

function Boom:OnEvent(f)
	BooVar = BooVar or Boom:GetDefaults()
	BooVar.Disable = BooVar.Disable or {}
	Boom:Load()
	Boom:SlashCommands()
	
	if BoomyVariables then
		BoomyVariables = nil
	end
	
	f:SetScript("OnEvent", nil)
end

function Boom:Load()
	Boom.ActionBar = CreateFrame("Button", "BoomyBalanceActionBar", UIParent)
	Boom.ActionBar:SetClampedToScreen(true)
	Boom.ActionBar:EnableMouse(false)
	
	Boom.ActionBar.func = function()
		Boom:ToggleHotkeyText()
	end

	
	local menu = Boom:FrameOptions()
	
	Boom.ActionBar:SetScript("OnClick", function()
		ToggleFrame(menu)
	end)
	
	Boom.ActionBar:SetFrameLevel(10)
	for i = 1, twelve do
		Boom.buttons[i] = Boom:CreateButton(i)
	end
	for i = 1, twelve do
		GorLib.EnableMasque('BoomyBalance', Boom.buttons[i])
	end
	
	GorLib.EnableKeyBound(Boom.buttons)
	local f = CreateFrame("Frame")
	f:RegisterEvent("PLAYER_TALENT_UPDATE")
	f:SetScript("OnEvent", function()
		Boom:OnSpecChanged(Boom:GetCurrentSpec(GetPrimaryTalentTree()))
	end)
	f:GetScript("OnEvent")()
	Boom:Layout()
	GorLib.Rescale(Boom.ActionBar, BooVar.layout.scale)
	GorLib.Repos(Boom.ActionBar, BooVar.position)
	Boom:Options()
	
	BooVar.Disable = BooVar.Disable or {}
end

function Boom:GetCurrentSpec(i)
	if i == 1 then
		return "Balance"
	elseif i == 2 then
		return "Feral"
	elseif i == 3 then
		return "Restoration"
	end
end

function Boom:OnSpecChanged(spec)
	if spec then
		for i = 1, twelve do
			Boom:SetupButton(i, spec)
		end
	end
	
	if BooVar.Disable[spec] then
		Boom.ActionBar:Hide()
	else
		Boom.ActionBar:Show()
	end
	
end

--Create and enable the buttons
function Boom:CreateButton(i)
	local b = _G["BoomyBalanceActionButton"..i] or CreateFrame("CheckButton", "BoomyBalanceActionButton"..i, Boom.ActionBar, "BoomyBalanceButtonTemplate")
	return b
end

local function UpdateTooltip(self, info)
	if GameTooltip:GetOwner() ~= self then
		return
	end

	local B, D
	if info.name2 then
		B = UnitBuff("player", GetSpellInfo(info.id2), nil, "PLAYER")
		if info.type == 2 then
			D = UnitBuff("player", GetSpellInfo(48517), nil, "PLAYER")
		end
	end
	if B or D then
		GameTooltip:SetSpellByID(info.id2)
	else
		GameTooltip:SetSpellByID(info.id)
	end
end

local function UpdateState(self, info)
	local isUsable, notEnoughMana = IsUsableSpell(info.id)
	inRange = IsSpellInRange(info.name, "target")
	if ( inRange  == 0 ) then
		self.icon:SetVertexColor(1.0, 0.1, 0.1)
	elseif ( isUsable ) then
		self.icon:SetVertexColor(1.0, 1.0, 1.0)
	elseif ( notEnoughMana ) then
		self.icon:SetVertexColor(0.5, 0.5, 1.0)
	else
		self.icon:SetVertexColor(0.4, 0.4, 0.4)
	end
end

local function UpdateTexture(self, info)
	self.name, _, self.texture = GetSpellInfo(info.id)
	if info.name2 and (info.type == 4) then
		self.texture3 = select(3, UnitBuff("player", info.name2, nil, "PLAYER") )
	end
	self.icon:SetTexture(self.texture)
	if self.texture3 then
		self.icon:SetTexture(self.texture3)
	else
		self.icon:SetTexture(self.texture)
	end
	
	self.icon:Show()
	self.rangeTimer = -1
	if IsCurrentAction(info.id) ==1 then
		self:SetChecked(1)
	else
		self:SetChecked(nil)
	end
end

local function CD_Info(self, info)
	self.action = info.id
	local buff, buff1, D, E
	buff1, _, _, self.countText, _, self.D1, self.E1 = UnitDebuff("target", info.name, nil, "PLAYER")
	if info.name2 or (info.type == 6) then
		buff, _, _, _, _, D, E  = UnitBuff("player", info.name2)
		self.buff2, _, _, _, _, self.D2, self.E2 = UnitDebuff("target", info.name2, nil, "PLAYER")
	end
	
	self.buff = buff or buff1 or self.buff2
	self.D = D or self.D1 or self.D2
	self.E = E or self.E1 or self.E2
	self.name, _, self.texture = GetSpellInfo(info.id)
	self.start, self.duration = GetSpellCooldown(info.id)
end

local function UpdateCooldown(self, info)
	if (((info.type == 2) and UnitExists("target") and not UnitIsDead("target")) or (info.type == 3) or (info.type == 4) or ((info.type == 6)) or (info.type == 5))  and self.buff then
		CooldownFrame_SetTimer(self.cd, (self.E - self.D), self.D, 1)
	else
		CooldownFrame_SetTimer(self.cd, (self.start), self.duration, 1)
	end
end

local function UpdateText(self, info)
	if not self.count then 
		return
	end

	if self.countText and (self.countText > 0) then
		self.count:SetText(self.countText)
	else
		self.count:SetText("")
	end
end

local function SpellUsable(self, type, info)
	if type and (info.type == type) and UnitExists("target") and UnitCanAttack("player", "target") and not UnitIsDead("target") then
		return true
	elseif not type and (self.duration < 1.313) and UnitExists("target") and UnitCanAttack("player", "target") and not UnitIsDead("target") then
		return true
	else
		return false
	end 
end

local function UpdateIconOverlay(self, info)
	if ((SpellUsable(self, 2, info) == true) and not self.buff) or (((info.type == 3) or (info.type == 4) or (info.type == 5) or ((info.type == 6) and self.buff)) and (SpellUsable(self, nil, info) == true)) or ( IsSpellOverlayed(info.id) ) then
		ActionButton_ShowOverlayGlow(self)	 
	else
		ActionButton_HideOverlayGlow(self)
	end
end

function Boom:SetupButton(i, spec)
	local b = Boom.buttons[i]

	local info = Boom[spec.."Info"](BooVar.button[spec].spell[i])
		
	if not info then
		return
	end
		
	b.action = info.id
	b:SetAttribute("spell", info.name);								 
	b:SetAttribute("id", info.id)
	b:SetScript("OnUpdate", function(self)
		UpdateTexture(self, info)
		UpdateTooltip(self, info)
		UpdateState(self, info)
		CD_Info(self, info)
	end)
		
	b:SetScript("OnEvent", function(self, event, ...)
		CD_Info(self, info)
		UpdateTexture(self, info)
		UpdateState(self, info)
		UpdateIconOverlay(self, info)
		UpdateCooldown(self, info)
		UpdateIconOverlay(self, info)
		UpdateTexture(self, info)
		UpdateState(self, info)
		UpdateText(self, info)
		UpdateTooltip(self, info)
	end)
		
	UpdateTexture(b, info)
end

--Layout
function Boom:Layout()
	GorLib.Layout(Boom.ActionBar, BooVar.layout or Boom:GetDefaults().layout, Boom.buttons)
end

function Boom:GetSpellDefaults()
	return {
			1, -- [1]
			2, -- [2]
			3, -- [3]
			4, -- [4]
			5, -- [5]
			6, -- [6]
			7, -- [7]
			8, -- [8]
			9, -- [9]
			10,
			11,
			12,
		}
end

function Boom:GetDefaults()
	return {
		button = {
			Balance = {
				spell = Boom:GetSpellDefaults(),
			},
			Restoration = {
				spell = Boom:GetSpellDefaults(),
			},
			Feral = {
				spell = Boom:GetSpellDefaults(),
			},
		},
		layout = {
			scale = 1,
			columns = 3,
			space = 0,
			LtR = 1,
			TtB = 1,
			pad = 0,
			hotkey = 1,
		},
		position = {
			y = 0,
			x = 0,
			point = "Center",
		},
	}
end

function Boom:SlashCommands()
	Boom.Main:Hide()
	SLASH_BOOM1 = '/boomy'
	local function handler(msg, editbox)
		local m = string.lower(msg)
		if m == ( "o" ) or m == ( "op" ) or m == ( "opt" ) or m == ( "opti" ) or m == ( "optio" ) or m == ( "option" ) or m == ( "options" ) then
			if Boom.Main:IsVisible() then
				InterfaceOptionsFrameOkay:GetScript("OnClick")(InterfaceOptionsFrameOkay, "LeftButton")
				Boom.Main:Hide()
			else
				Boom.Main:Show()
				InterfaceOptionsFrame_OpenToCategory(Boom.Main)
			end
		elseif m == "disable" then
			print(m)
			
			if BooVar.Disable[Boom:GetCurrentSpec(GetPrimaryTalentTree())] then
				BooVar.Disable[Boom:GetCurrentSpec(GetPrimaryTalentTree())] = nil
			else
				BooVar.Disable[Boom:GetCurrentSpec(GetPrimaryTalentTree())] = 1
			end
			
			Boom:OnSpecChanged(Boom:GetCurrentSpec(GetPrimaryTalentTree()))	
		else
			Boom:ToggleConfig()
		end
	end
	SlashCmdList['BOOM'] = handler
end

function Boom:ToggleConfig()
	local self = Boom.ActionBar
	if not Boom.Cmode then
		Boom.Cmode = 1
		self:SetBackdrop( {bgFile = "Interface\\TargetingFrame\\BarFill2"})
		self:SetBackdropColor(1, 0, 0, .75)
		self:RegisterForClicks("AnyUp")
		self:EnableMouse(true)
		
		function self.OnDragStop(self) self:StopMovingOrSizing() GorLib.SavePos(self, BooVar.position) end
		function self.OnDragStart(self)	self:StartMoving() end
		local handlers = {"OnDragStart", "OnDragStop"}
		self:RegisterForDrag("LeftButton")
		for _, handler in ipairs(handlers) do
  		  self:SetScript(handler, function(self, button) self[handler](self) end)
		end
	else
		Boom.Cmode = nil
		self:EnableMouse(false)
		self.OnDragStop(self)
		self:SetBackdrop( {bgFile = ""})
	end
end

--Spell Info
do
	local table
	function Boom.BalanceInfo(i)
		table = {
			[1] = {name = "Starsurge",				name2 = "Shooting Stars",	id = 78674,  id2 = 93400,	type = 4},
			[2] = {name = "Starfire",				name2 = nil,				id = 2912,	 id2 = nil,		type = 1},
			[3] = {name = "Faerie Fire",			name2 = nil,				id = 770,	 id2 = nil,		type = 2},
			[4] = {name = "Moonfire",				name2 = "Sunfire",			id = 8921,	 id2 = 93402,	type = 2},
			[5] = {name = "Wrath",					name2 = nil,				id = 5176,	 id2 = nil,		type = 1},
			[6] = {name = "Insect Swarm",			name2 = nil,				id = 5570,	 id2 = nil,		type = 2},
			[7] = {name = "Force of Nature",		name2 = nil,				id = 33831,	 id2 = nil,		type = 5},
			[8] = {name = "Wild Mushroom",			name2 = nil,				id = 88747,	 id2 = nil,		type = 1},
			[9] = {name = "Wild Mushroom: Detonate",name2 = nil,				id = 88751,	 id2 = nil,		type = 3},
			[10] = {name = "Clearcasting",			name2 = "Clearcasting",		id = 16870,	 id2 = 16870,	type = 6},
			[11] = {name = "Nature's Grace",		name2 = "Nature's Grace",	id = 61346,	 id2 = 61346,	type = 6},
			[12] = {name = "Solar Beam",			name2 = nil,				id = 97547,	 id2 = nil,		type = 1},
			[13] = {name = "Innervate",				name2 = nil,				id = 29166,	 id2 = nil,		type = 1},
			[14] = {name = "Hurricane",				name2 = nil,				id = 16914,	 id2 = nil,		type = 1},
			[15] = {name = "Starfall",				name2 = nil,				id = 48505,	 id2 = nil,		type = 1},
			[16] = {name = "Typhoon",				name2 = nil,				id = 50516,	 id2 = nil,		type = 1},
			[17] = {name = "Cyclone",				name2 = nil,				id = 33786,	 id2 = nil,		type = 1},
			[18] = {name = "Entangling Roots",		name2 = nil,				id = 339,	 id2 = nil,		type = 1},
			[19] = {name = "Hibernate",				name2 = nil,				id = 2637,	 id2 = nil,		type = 1},
			}
		return table[i]
	end
end
function Boom.Balance()
	Balance = {}
	
	for i = 1, 19 do
		Balance[i] = Boom.BalanceInfo(i).name
	end	
	
	return Balance
end

do
	local table
	function Boom.RestorationInfo(i)
		table = {
			[1] = {name = "Rejuvenation", 		id = 774},
			[2] = {name = "Wild Growth", 		id = 48438},
			[3] = {name = "Nourish", 			id = 50464},
			[4] = {name = "Regrowth",			id = 8936},
			[5] = {name = "Healing Touch",		id = 5185},
			[6] = {name = "Lifebloom",			id = 33763},
			[7] = {name = "Swiftmend",			id = 18562},
			[8] = {name = "Tree of Life",		id = 33891},
			[9] = {name = "Tranquility",		id = 740},
			[10] = {name = "Mark of the Wild",	id = 85},
			[11] = {name = "Innervate",		id = 87},
			[12] = {name = "Thorns",		id = 65},			
			}
		return table[i]
	end
end
function Boom.Restoration()
	Restoration = {}
	for i = 1, 12 do
		Restoration[i] = Boom.RestorationInfo(i).name
	end	
	return Restoration
end

do
	local table 
	function Boom.FeralInfo(i)
		table = {
		{
			["id"] = 84735,
			["name"] = "Aggression",
		}, -- [1]
		{
			["id"] = 5211,
			["name"] = "Bash (Bear Form)",
		}, -- [2]
		{
			["id"] = 50334,
			["name"] = "Berserk (Cat or Bear Form)",
		}, -- [3]
		{
			["id"] = 5209,
			["name"] = "Challenging Roar (Bear Form)",
		}, -- [4]
		{
			["id"] = 1082,
			["name"] = "Claw (Cat Form)",
		}, -- [5]
		{
			["id"] = 8998,
			["name"] = "Cower (Cat Form)",
		}, -- [6]
		{
			["id"] = 1850,
			["name"] = "Dash (Cat Form)",
		}, -- [7]
		{
			["id"] = 99,
			["name"] = "Demoralizing Roar (Bear Form)",
		}, -- [8]
		{
			["id"] = 5229,
			["name"] = "Enrage (Bear Form)",
		}, -- [9]
		{
			["id"] = 16857,
			["name"] = "Faerie Fire (Feral)",
		}, -- [10]
		{
			["id"] = 20719,

			["name"] = "Feline Grace",
		}, -- [11]
		{
			["id"] = 16979,
			["name"] = "Feral Charge (Bear Form)",
		}, -- [12]
		{
			["id"] = 49376,
			["name"] = "Feral Charge (Cat Form)",
		}, -- [13]
		{
			["id"] = 87335,

			["name"] = "Feral Instinct",
		}, -- [14]
		{
			["id"] = 22568,
			["name"] = "Ferocious Bite (Cat Form)",
		}, -- [15]
		{
			["id"] = 22842,
			["name"] = "Frenzied Regeneration (Bear Form)",
		}, -- [16]
		{
			["id"] = 6795,
			["name"] = "Growl (Bear Form)",
		}, -- [17]
		{
			["id"] = 33745,
			["name"] = "Lacerate (Bear Form)",
		}, -- [18]
		{
			["id"] = 22570,
			["name"] = "Maim (Cat Form)",
		}, -- [19]
		{
			["id"] = 33876,
			["name"] = "Mangle (Cat Form)",
		}, -- [20]
		{
			["id"] = 33878,
			["name"] = "Mangle (Bear Form)",
		}, -- [21]
		{
			["id"] = 6807,
			["name"] = "Maul (Bear Form)",
		}, -- [22]
		{
			["id"] = 9005,
			["name"] = "Pounce (Cat Form)",
		}, -- [23]
		{
			["id"] = 5215,
			["name"] = "Prowl (Cat Form)",
		}, -- [24]
		{
			["id"] = 80313,
			["name"] = "Pulverize (Bear Form)",
		}, -- [25]
		{
			["id"] = 1822,
			["name"] = "Rake (Cat Form)",
		}, -- [26]
		{
			["id"] = 6785,
			["name"] = "Ravage (Cat Form)",
		}, -- [27]
		{
			["id"] = 1079,
			["name"] = "Rip (Cat Form)",
		}, -- [28]
		{
			["id"] = 62600,

			["name"] = "Savage Defense",
		}, -- [29]
		{
			["id"] = 52610,
			["name"] = "Savage Roar (Cat Form)",
		}, -- [30]
		{
			["id"] = 5221,
			["name"] = "Shred (Cat Form)",
		}, -- [31]
		{
			["id"] = 80965,
			["name"] = "Skull Bash (Cat Form)",
		}, -- [32]
		{
			["id"] = 80964,
			["name"] = "Skull Bash (Bear Form)",
		}, -- [33]
		{
			["id"] = 77764,
			["name"] = "Stampeding Roar (Cat Form)",
		}, -- [34]
		{
			["id"] = 77761,
			["name"] = "Stampeding Roar (Bear Form)",
		}, -- [35]
		{
			["id"] = 61336,
			["name"] = "Survival Instincts (Cat or Bear Form)",
		}, -- [36]
		{
			["id"] = 62078,
			["name"] = "Swipe (Cat Form)",
		}, -- [37]
		{
			["id"] = 779,
			["name"] = "Swipe (Bear Form)",
		}, -- [38]
		{
			["id"] = 77758,
			["name"] = "Thrash (Bear Form)",
		}, -- [39]
		{
			["id"] = 5217,
			["name"] = "Tiger's Fury (Cat Form)",
		}, -- [40]
		{
			["id"] = 84840,

			["name"] = "Vengeance",
		}, -- [41]
	}
		return table[i]
	end
end
function Boom.Feral()
	Feral = {}
	for i = 1, 41 do
		Feral[i] = Boom.FeralInfo(i).name
	end	
	return Feral
end

--Frame Options Menu
function Boom:FrameOptions()
	local menu = GorLib.NewMenu("BoomyBalanceFrameOptions", nil, "BoomyBalance Options")
	menu:SetSize(218, 244)
	
	local function LayoutSlider(title, low, high, vari)
		local s = GorLib.NewSlider(title, menu, low, high, 1)
		s.OnValueChanged = function(self, value)
			if vari == "scale" then
				GorLib.SetFrameScale(BoomyBalanceActionBar, BooVar.layout, value/100)
			else
				BooVar.layout[vari] = value
				Boom:Layout()
			end
		end
		s.OnShow = function(self)
			if vari == "scale" then
				self:SetValue(BooVar.layout[vari]*100)
			else
				self:SetValue(BooVar.layout[vari])
			end
		end
	end

	LayoutSlider("Padding", -16, 32,  "pad")
	LayoutSlider("Spacing", -16, 32,  "space")
	LayoutSlider("Columns",  1,  twelve,   "columns")
	LayoutSlider("Scale", 	50,  150, "scale")	
	
	local function Check(title, option, vari)
		local c = GorLib.NewCheckButton(title, menu)
		c.OnShow = function(self)
			self:SetChecked(BooVar[option][vari])
		end
		c.OnClick = function(self)
			BooVar[option][vari] = self:GetChecked()
			if vari ~= "hotkey" then
				Boom:Layout()
			else
				Boom:ToggleHotkeyText()
			end
		end
	end

	Check("Left to Right", "layout", "LtR")
	Check("Top to Bottom", "layout", "TtB")
	Check("Enable Hotkey Text", "layout", "hotkey")
	menu:Hide()	
	return menu
end

function Boom:Options()
	local function NewSpellMenu(parent, name, vari, table, value)
		local f = GorLib.NewDropMenu(parent, name, GorLib.ReverseTable(table), BooVar.button[vari].spell[value])
		f.OnClick = function(val)
			if not InCombatLockdown() then
				BooVar.button[vari].spell[value] = val
				Boom:OnSpecChanged(Boom:GetCurrentSpec(GetPrimaryTalentTree()))
			else
				print("BoomyBalance: Try again after leaving Combat!")
			end
		end
		return f
	end

	Boom.Main = GorLib.NewOptionsPanel("Boomy Balance", "Boomy Balance")
	
	local Opts = Boom.Main

	local gen = Opts:NewTab("General", 1, 1)
	
	local title = GorLib.NewString(gen)
		title.text = "Information"
	
	local a = GorLib.NewString(gen, 1, 1)
		a.text = "To rearrange the icons, select one of the other three tabs above and then use the dropdown menus to change the buttons."

	local b = GorLib.NewString(gen, 1, 1)
		b.text = "To move the BoomyBalanceActionBar, type '/boomy', and drag the bar around."
		
	local c = GorLib.NewString(gen, 1, 1)
		c.text = "To modify the BoomyBalanceActionBar, type '/boomy', and then click on the bar's red overlay."
		
	local d = GorLib.NewString(gen, 1, 1)
		d.text = "To enter Key Binding mode, type '/kb' or '/keybound'."
	
	local e = GorLib.NewString(gen, 1, 1)
		e.text = "To access this menu, type '/boomy o'"
		
	local f = GorLib.NewString(gen, 1, 1)
		f.text = "'/boomy disable' will disable the bar for your current spec."
	local function Tab(name)
		local tab =  Opts:NewTab(name, nil, 1)
			local F = CreateFrame("Frame", tab:GetName().."SpellMenus", tab)
			F:SetPoint("TopLeft", 200, 0)
			F:SetPoint("BottomLeft", 0, 0)
		
		for i = 1, twelve do
			F[i] = NewSpellMenu(tab, "Button "..i, name, Boom[name](), i)
			F[i]:ClearAllPoints()
			if i == 1 then
				F[i]:SetPoint("TopLeft", -5, -25)
			elseif i > 3 then
				F[i]:SetPoint("Left", F[i-3], "Right", 17, 0)
			else
				F[i]:SetPoint("Top", F[i-1], "Bottom",0, -10)
			end
			
		end
		return tab
	
	end

	local Balance = Tab("Balance")
	local Feral = Tab("Feral")
	local Resto = Tab("Restoration")
end

local f = CreateFrame("Frame")
f:RegisterEvent('PLAYER_ENTERING_WORLD')
f:SetScript('OnEvent', function(self, event)
		if (select(2, UnitClass('player')) == 'DRUID') then
			Boom:OnEvent(f)
		else
			f:SetScript("OnEvent", nil)
		end
end)
