local VERSION = 1
if GorLib.BasicMenu and GorLib.BasicMenu > VERSION then
	return --Version Control... YAY!
else
	GorLib.BasicMenu = VERSION
	GorLib.NewMenu = function(name, parent, titleText)
		local parent = parent or UIParent
		local menu
	
		if not _G[name] then
			menu = CreateFrame('Frame', name, parent, 'TranslucentFrameTemplate')
		else
			menu = _G[name]
		end
		menu:SetSize(220, 300)
		menu:Hide()
		menu:EnableMouse(true)
		menu:SetMovable(true)
		menu.close = CreateFrame('Button', menu:GetName()..'CloseButton', menu, 'UIPanelCloseButton')
		menu.close:SetPoint('TopRight', -5, -5)
		menu:SetScript("OnShow", function(self)
			self:SetPoint("Center")
		end)
	
		local title = menu:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		title:SetPoint("TopLeft", 15, -15)
		title:SetText(titleText or name)
		function menu:NewTab(title, focus, noTitle)
			return GorLib.NewTab(menu, title, focus, noTitle)
		end
	
		function menu.OnDragStop(self) self:StopMovingOrSizing()  end
		function menu.OnDragStart(self)	self:StartMoving() end
		local handlers = {"OnDragStart", "OnDragStop"}
		menu:RegisterForDrag("LeftButton")
		for _, handler in ipairs(handlers) do
  		  menu:SetScript(handler, function(self, button) self[handler](self) end)
		end
		return menu
	end
end