local VERSION = 1
if GorLib.DropDown and GorLib.DropDown > VERSION then
	return --Version Control... YAY!
else
	GorLib.DropDown = VERSION
	GorLib.NewDropMenu = function(parent, name, table, val, ShowIcon, OnShow)
		local menu 
		if not _G[parent:GetName()..name..'DropMenu'] then
 			menu = CreateFrame('Button', parent:GetName()..name..'DropMenu', parent, 'UIDropDownMenuTemplate')
		else
			menu = _G[parent:GetName()..name..'DropMenu']
		end
		menu.title = parent:CreateFontString(nil, 'OVERLAY', 'GameFontNormal')
		menu.title:SetPoint('BOTTOMLEFT', menu, 'TOPLEFT',20,0)
		menu.title:SetText(name)
		menu:SetID(random(1, 1000))

		local function OnClick(self)
			UIDropDownMenu_SetSelectedID(menu, self:GetID())
			menu.id =  UIDropDownMenu_GetValue(self:GetID())
			menu.text = self:GetID()
			UIDropDownMenu_SetText(menu, menu.id)
			UIDropDownMenu_Initialize(menu, initialize)
			menu.OnClick(table[menu.id])
		end

		local function initialize(self, level)
			local info = UIDropDownMenu_CreateInfo()
			for k,v in pairs(table) do
				info = UIDropDownMenu_CreateInfo()
				info.text = k
				info.value = k
				info.func  = OnClick
				if ShowIcon then
					info.icon = v
				end
				info.arg1 = menu
				info.notCheckable = 1
				UIDropDownMenu_AddButton(info, level)
				if table[k] == val then
					UIDropDownMenu_SetText(menu, k)
				end
			end
			local CloseMenu = {text = "Close Menu", colorCode = "|cff991111",	func = function() CloseDropDownMenus() end, notCheckable = 1}
			UIDropDownMenu_AddButton(CloseMenu , level)
		end

		if OnShow then
			menu:SetScript("OnShow", function() OnShow(menu) end)
		end

		UIDropDownMenu_SetWidth(menu, 130, 0)
		UIDropDownMenu_SetButtonWidth(menu, 130) 
		UIDropDownMenu_Initialize(menu, initialize)
		UIDropDownMenu_JustifyText(menu, 'LEFT')

		local prev = parent.PrevDrop
		if prev then
			menu:SetPoint("Top", prev, "Bottom",0, -20)
		else
			menu:SetPoint("TopLeft", 5, -30)
		end
		parent.PrevDrop = menu
		
		return menu
	end
end