local VERSION = 1
if GorLib.OptionsPanel and GorLib.OptionsPanel > VERSION then
	return --Version Control... YAY!
else
	GorLib.OptionsPanel = VERSION
	GorLib.NewOptionsPanel = function(name, title, parent)
		local panel
		if _G[name.."Options"] then
			panel = _G[name.."Options"]
		else
			panel = CreateFrame('FRAME', name.."Options", UIParent)
		end
		
		panel.name = name;
	
		if parent then
			panel.parent = parent.name
		end
		
		function panel:NewChild(childName)
			return GorLib.NewOptionsPanel(childName, title, parent)
		end
	
		function panel:NewTab(title, focus, noTitle)
			return GorLib.NewTab(panel, title, focus, noTitle)
		end
		
		if title then
			panel.title = panel:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
			panel.title:SetPoint("TopLeft", 5 ,-5)
			panel.title:SetText(title)
		end
	
		InterfaceOptions_AddCategory(panel)
	
		return panel
	end
end