local VERSION = 1
if GorLib.ScrollFrame_Double and GorLib.ScrollFrame_Double > VERSION then
	return --Version Control... YAY!
else
	GorLib.ScrollFrame_Double  = VERSION
	GorLib.DoubleScrollFrame = function(parent)
		local scroll = CreateFrame("ScrollFrame", parent:GetName().."DoubleScrollFrame", parent, "FauxScrollFrameTemplate")
		scroll:SetPoint("TopLeft", 15, -35)
		scroll:SetPoint("BottomRight", -25, 25)
		_G[scroll:GetName().."ScrollBar"]:Hide()

		scroll.Slider1 = CreateFrame("Slider", scroll:GetName().."ScrollBar1", scroll,"OptionsSliderTemplate")
		scroll.Slider1:SetOrientation("VERTICAL")
		scroll.Slider1:SetPoint("TopLeft", scroll, "TopRight", 0, 0)
		scroll.Slider1:SetPoint("BottomLeft", scroll, "BottomRight", 0, 0)
		scroll.Slider1:SetWidth(10)
		scroll.Slider1:SetScript("OnValueChanged", function(self, value)
			self:GetParent():SetVerticalScroll(value)
		end)
		scroll.Slider1:SetScript("OnMouseWheel", function(self, value)
			if value > 0 then
				 self:SetValue(self:GetValue() - (self:GetHeight() / 2))
			else
    		    self:SetValue(self:GetValue() + (self:GetHeight() / 2));
    		end
		end)
		scroll.Slider1:SetMinMaxValues(0, 0)
		scroll.Slider1:SetValue(0)

		_G[scroll.Slider1:GetName() .. 'Low']:SetText("");
		_G[scroll.Slider1:GetName() .. 'High']:SetText("");
		_G[scroll.Slider1:GetName() .. 'Text']:SetText(""); 

		scroll.Slider2 = CreateFrame("Slider", scroll:GetName().."ScrollBar2", scroll,"OptionsSliderTemplate")
		scroll.Slider2:SetOrientation("HORIZONTAL")
		scroll.Slider2:SetPoint("TopLeft", scroll, "BottomLeft", 0, 0)
		scroll.Slider2:SetPoint("TopRight", scroll, "BottomRight", 0, 0)
		scroll.Slider2:SetHeight(16)
		scroll.Slider2:SetScript("OnValueChanged", function(self, value)
			self:GetParent():SetHorizontalScroll(value)
		end)
		scroll.Slider2:SetScript("OnMouseWheel", function(self, value)
			if value > 0 then
				 self:SetValue(self:GetValue() - (self:GetHeight() / 2))
			else
		        self:SetValue(self:GetValue() + (self:GetHeight() / 2));
		    end
		end)
		scroll.Slider2:SetMinMaxValues(0, 0)
		scroll.Slider2:SetValue(0)

		_G[scroll.Slider2:GetName() .. 'Low']:SetText("");
		_G[scroll.Slider2:GetName() .. 'High']:SetText("");
		_G[scroll.Slider2:GetName() .. 'Text']:SetText("");
	
	
		scroll.Adjust = function(self, i, height, width)
			local offset = (height * i )
	
			self:SetPoint("TopLeft", 0, (height-offset) )

			if offset > height then
				scroll.Slider1:SetMinMaxValues(0, (offset - scroll:GetHeight()))
			else
				scroll.Slider1:SetMinMaxValues(0, 0)
			end

			if width > scroll:GetWidth() then
				scroll.Slider2:SetMinMaxValues(0, (width - scroll:GetWidth()))
			else
				scroll.Slider2:SetMinMaxValues(0, 0)
			end
		end
		
		return scroll
	end
end
