local VERSION = 1
if GorLib.Slider and GorLib.Slider > VERSION then
	return --Version Control... YAY!
else
	GorLib.Slider = VERSION
	GorLib.NewSlider = function(name, parent, low, high, step)
		local slider
		if not _G[name..parent:GetName()] then
			slider = CreateFrame("Slider", name..parent:GetName(), parent, "OptionsSliderTemplate")
		else
			slider = _G[name..parent:GetName()]
		end
		slider:SetValueStep(step)
		slider.label = _G[slider:GetName().."Text"]
		slider.minLabel = _G[slider:GetName().."Low"]
		slider.maxLabel = _G[slider:GetName().."High"]
		slider.label:SetText(name)
		slider.label:SetTextColor(1, 1, 0, 1)
		slider.minLabel:SetText(low)
		slider.minLabel:ClearAllPoints()
		slider.minLabel:SetPoint("Right", slider, "Left", -1, 0)
		slider.maxLabel:SetText(high)
		slider.maxLabel:ClearAllPoints()
		slider.maxLabel:SetPoint("Left", slider, "Right", 1, 0)
		slider:EnableMouseWheel(true)
		slider:SetMinMaxValues(low, high)
		slider.label:SetPoint("BottomLeft", slider, "TopLeft")
		slider:SetScript("OnShow", function(self) self.OnShow(self) end)
		slider.valLabel = slider:CreateFontString(nil, "OVERLAY", "GameFontHighlight")
		slider.valLabel:SetPoint("BottomRight", slider, "TopRight")	
		slider.valLabel:SetTextColor(0, .5, 1, 1)
		slider:SetScript("OnValueChanged", function(self, value)
		self.OnValueChanged(self, value)
			self.valLabel:SetText(value)
		end)
		slider:SetScript('OnMouseWheel', function(self, arg1)
			local step, value = self:GetValueStep() * arg1, self:GetValue()
			local minVal, maxVal = self:GetMinMaxValues()
			if step > 0 then
				self:SetValue(min(value+step, maxVal))
			else
				self:SetValue(max(value+step, minVal))
			end
		end)
    	local prev = parent.Prevslider
		if prev then
			slider:SetPoint("Bottom", prev, "Top",0, 10)
			slider:SetWidth(prev:GetWidth())
		else
			slider:SetPoint("Bottom", 0, 20)
		end
		parent.Prevslider = slider
		return slider
	end
end