local VERSION = 1
if GorLib.Tab and GorLib.Tab > VERSION then
	return --Version Control... YAY!
else
	GorLib.Tab = VERSION
	GorLib.NewTab = function(parent, name, focus, noTitle)
		local tab = CreateFrame("Button", parent:GetName()..name.."Tab", parent, "OptionsFrameTabButtonTemplate")

		local menu = CreateFrame("Frame", parent:GetName()..name.."Menu", parent, "InsetFrameTemplate2")


		function menu:NewTab(title, focus, noTitle)
			return GorLib.NewTab(menu, title, focus, noTitle)
		end


		if not noTitle then
			menu.Title = menu:CreateFontString(nil, "OVERLAY", "GameFontNormalLarge")
			menu.Title:SetPoint("TopLeft", 20, -10)
			menu.Title:SetText(name)
		end

		menu:SetPoint("TopLeft", parent, 10, -60)
		menu:SetPoint("BottomRight", parent, -10, 10)

		if focus then
			menu:Show()
			PanelTemplates_SelectTab(tab);
		else
			menu:Hide()
			PanelTemplates_DeselectTab(tab);
		end

		if not parent.menu then
			parent.menu = {}
		end

		tinsert(parent.menu, menu)

		tab:SetScript("OnClick", function()
			for i = 1, #parent.menu do
				if parent.menu[i] == menu then
					parent.menu[i]:Show()
					PanelTemplates_SelectTab(parent.tabs[i]);
				else
					parent.menu[i]:Hide()
					PanelTemplates_DeselectTab(parent.tabs[i]);
				end
			end
		end)

		if not parent.tabs then
			parent.tabs = {}
		end

		tinsert(parent.tabs, tab)
		tab:SetText(name)

		local prev = parent.tab
		if prev then
			tab :SetPoint("Left", prev, "Right",-18, 0)
		else
			tab :SetPoint("Bottomleft", menu, "TopLeft", 5, 0)
		end

		PanelTemplates_TabResize(tab)

		parent.tab = tab
		return menu, tab
	end
end