VERSION = 1
if GorLib.ButtonBarLayout and GorLib.ButtonBarLayout > VERSION then
	return
else
	GorLib.ButtonBarLayout = VERSION

	GorLib.Layout = function(self, sets, kids)
		local layout = sets
		local NumButtons = #kids

		if NumButtons > 0 then
			local cols = min(layout.columns, NumButtons)
			local spacing = layout.space
			local pH, pW = layout.pad, layout.pad
		
			local rows = ceil(NumButtons / cols)
		
			local LtR, TtB = layout.LtR, layout.TtB
			local b = kids[1]
			local WIDTH_OFFSET, HEIGHT_OFFSET
		
			local L, R, T, B = b:GetHitRectInsets()
			if T > 0 then
				HEIGHT_OFFSET = T + 2
			else
				HEIGHT_OFFSET = 0
			end
			if (R > 0) or (L > 0) then
				WIDTH_OFFSET = L + R + 2
			else
				WIDTH_OFFSET =  0
			end
			local w = b:GetWidth() + spacing - WIDTH_OFFSET
			local h = b:GetHeight() + spacing - HEIGHT_OFFSET
		
			for i, b in pairs(kids) do
				b:ClearAllPoints()
				b:SetParent(self)
				if self:GetFrameLevel() == 5 then
					b:SetFrameLevel(1)
				end
				local col
				local row
				if LtR then
					col = (i-1) % cols
				else
					col = (cols-1) - (i-1) % cols
				end
				if TtB then
					row = ceil(i / cols) - 1
				else
					row = rows - ceil(i / cols)
				end
				b:ClearAllPoints()
				b:SetPoint('TOPLEFT', w*col + pW, -(h*row + pH) + HEIGHT_OFFSET)
			end
		
			self:SetWidth(max(w*cols - spacing + pW*2 + WIDTH_OFFSET, 8))
			self:SetHeight(max(h*ceil(NumButtons/cols) - spacing + pH*2, 8))
		else
			self:SetSize(30, 30)
		end
	end

end